/* 2005-02-19 programmeerimisvistlus                                      */
/* lesanne: KALKULAATOR (edasijudnute rhm)                              */
/* Autor: Heno Ivanov                                                      */
/* Testitud: GCC 3.2 / MinGW                                               */

#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>

int nbasei(int n, char *s) {
	char *ptr = s;
	int ret = 0;
	assert((n >= 2) && (n <= 36));
	while (isalnum(*ptr)) {
		assert((ret >= 0) && (ret <= 1000000000));
		if (isdigit(*ptr))
			ret = ret * n + (*ptr - '0');
		if (isupper(*ptr))
			ret = ret * n + (*ptr - 'A' + 10);
		if (islower(*ptr))
			ret = ret * n + (*ptr - 'a' + 10);
		ptr++;
	}
	assert((ret >= 0) && (ret <= 1000000000));
	return ret;
}

char ntc(int n) {
	assert((n >= 0) && (n <= 35));
	if (n < 10)
		return ('0' + n);
	else
		return ('A' + n - 10);
}

char *nbaseo(int n, int v, char *buf) {
	char *ptr = buf;
	int vtmp = v;
	int vkord = 1;

	assert((n >= 2) && (n <= 36));
	assert((v >= 0) && (v <= 1000000000));

	while (vtmp >= n) {
		vtmp = vtmp / n;
		vkord = vkord * n;
	}

	while (vkord != 0) {
		int akord = 0;
		while (v >= vkord) {
			akord++;
			v = v - vkord;
		}

		*ptr = ntc(akord);

		if (vkord == 1) 
			vkord = 0;
		else 
			vkord = vkord / n;

		ptr++;
		assert(v >= 0);
	}
	*ptr = '\0';
	assert(ptr != buf); // ei tohi vljastada thja stringi.
	return buf;
}

int main() {
	char buf[100];
	int  ibase, obase;
	char ibuf[1000];
	int  n;
	int  i;
	FILE *fi, *fo;

	fi = fopen("ekalk.sis", "r");
	fo = fopen("ekalk.val", "w");

	ibase = obase = 10;

	fscanf(fi, "%d\n", &n);
	for (i = 1; i <= n; i++) {
		assert((ibase >= 2) && (ibase <= 36));
		assert((obase >= 2) && (obase <= 36));
		fgets(ibuf, sizeof(ibuf), fi);
		if (!strncmp(ibuf, "ibase=", 6)) {
//			printf("processing ibase: %s\n", ibuf);
			ibase = nbasei(ibase, ibuf+6);
//			printf("ibase set to %d\n",ibase);
			continue;
		}
		if (!strncmp(ibuf, "obase=", 6)) {
//			printf("processing obase: %s\n", ibuf);
			obase = nbasei(ibase, ibuf+6);
//			printf("obase set to %d\n", obase);
			continue;
		}
		fprintf(fo, "%s\n", nbaseo(obase, nbasei(ibase, ibuf), buf));
	}

	fclose(fo);
	fclose(fi);
	return 0;
}
