#!/usr/bin/perl
#
# *.tpl fail sisaldab testi 10-ssteemis
# ekalktestgen.pl ekalktest.NN genereerib sellest .sis ja .val failid
#

use strict;

die "argment required" unless $#ARGV > -1;

my $template = $ARGV[0] . ".tpl";
my $sisfile = ">" . $ARGV[0] . ".sis";
my $valfile = ">" . $ARGV[0] . ".val";

print "template = " . $template . "\n";

open(F, $template);
open(SIS, $sisfile);
open(VAL, $valfile);

my $rcount = 0;
my @sisfile;

my $ibase = 10;
my $obase = 10;

while (<F>) {
	if (/=/) {
		if (/ibase=/) {
			s/ibase=//g;
			push @sisfile, "ibase=" . &nbaseo($ibase, $_);
			$ibase = $_;
		}
		if (/obase=/) {
			s/obase=//g;
			push @sisfile,"obase=" . &nbaseo($ibase, $_);
			$obase = $_;
		}
	} else {
		print VAL &nbaseo($obase,$_) . "\n";
		push @sisfile, &nbaseo($ibase, $_);
	}
}

print SIS scalar @sisfile . "\n";
print SIS join("\n", @sisfile);
print SIS "\n";
close(F);
close(VAL);
close(SIS);

exit 0;

sub ntc {
	my ($n) = @_;
	if (($n >= 0) && ($n <= 9)) {
		return chr(ord('0') + $n);
	} else {
		return chr(ord('A') + $n - 10);
	}
}

sub nbaseo {
	my ($n,$v) = @_;
	my $vtmp = $v;
	my $vkord = 1;
	my $ret;

	while ($vtmp >= $n) {
		$vtmp = int($vtmp / $n);
		$vkord = $vkord * $n;
	}

	while ($vkord != 0) {
		my $akord = 0;
		while ($v >= $vkord) {
			$akord++;
			$v = $v - $vkord;
		}

		$ret = $ret . &ntc($akord);

		if ($vkord == 1) {
			$vkord = 0;
		} else {
			$vkord = int($vkord / $n);
		}
	}
	return $ret;
}
